#!/bin/sh
# $Id: t-mcpconf-1.sh,v 1.1 2007/11/30 05:51:37 ca Exp $

# ------------------------------------------------------------
# read configuration file and print it
# uses mcpconf
# ------------------------------------------------------------

test -s stop && exit 1

# source directory of this (and other) shell script
SD=`dirname $0`

ERRS=0

CNF=mcp0.conf
OUT=mcp0.out
OK=mcp0.ok

PRG=./mcpconf

cat > ${CNF} <<EOF
CDB_base_directory = "/var/spool/MeTA1/";
smtps {
  IO_timeout = 60;
  wait_for_server = 4;
	listen_socket { type=inet; port = 25; }
	start_action = pass;
	pass_fd_socket = smtps/smtpsfd;
	user = smxs;
	path = "/var/spool/smx/libexec/smtps";
	arguments = "smtps -f smx.conf";
}

smtpc {
  wait_for_server = 4;
  Log_Level = 12;
  IO_timeout = 66;
	start_action = wait;
	user = smxc;
	path = "/var/spool/smx/libexec/smtpc";
	arguments = "smtpc -f smx.conf";
}
EOF

cat > ${OK} <<EOF
smtps {
port          = 25;
pass_fd_socket= "smtps/smtpsfd";
pass_fd_socket_abs= "/var/spool/MeTA1/smtps/smtpsfd";
user          = "smxs";
start_action  = 4;
path          = "/var/spool/smx/libexec/smtps";
args          = "smtps -f smx.conf";
}
smtpc {
port          = 25;
user          = "smxc";
start_action  = 2;
path          = "/var/spool/smx/libexec/smtpc";
args          = "smtpc -f smx.conf";
}
EOF

if ${PRG} ${CNF} >${OUT}
then
  if diff -w ${OK} ${OUT}
  then
    :
  else
    ERRS=`expr ${ERRS} + 1 `
    test X"${MTA_STOPONERROR}" != X && exit 1
  fi
else
  ERRS=`expr ${ERRS} + 1 `
  test X"${MTA_STOPONERROR}" != X && exit 1
fi

cat > ${CNF} <<EOF
CDB_base_directory = "/var/spool/MeTA1/";
smtps MSA {
	start_action = pass;
	pass_fd_socket = smtps/smtpsmsa;
	user = smxs;
	path = "/var/spool/smx/libexec/smtps";
	arguments = "smtps -N MSA -f smx.conf";
}

smtps MTA {
	start_action = pass;
	pass_fd_socket = smtps/smtpsmta;
	user = smxs;
	path = "/var/spool/smx/libexec/smtps";
	arguments = "smtps -N MTA -f smx.conf";
}

smtpc {
	listen_socket { type=inet; port = 25; }
	start_action = wait;
	user = smxc;
	path = "/var/spool/smx/libexec/smtpc";
	arguments = "smtpc -f smx.conf";
}
EOF

cat > ${OK} <<EOF
smtps {
pass_fd_socket= "smtps/smtpsmsa";
pass_fd_socket_abs= "/var/spool/MeTA1/smtps/smtpsmsa";
user          = "smxs";
start_action  = 4;
path          = "/var/spool/smx/libexec/smtps";
args          = "smtps -N MSA -f smx.conf";
}
smtps {
pass_fd_socket= "smtps/smtpsmta";
pass_fd_socket_abs= "/var/spool/MeTA1/smtps/smtpsmta";
user          = "smxs";
start_action  = 4;
path          = "/var/spool/smx/libexec/smtps";
args          = "smtps -N MTA -f smx.conf";
}
smtpc {
port          = 25;
user          = "smxc";
start_action  = 2;
path          = "/var/spool/smx/libexec/smtpc";
args          = "smtpc -f smx.conf";
}
EOF

if ${PRG} ${CNF} >${OUT}
then
  if diff -w ${OK} ${OUT}
  then
    :
  else
    ERRS=`expr ${ERRS} + 1 `
    test X"${MTA_STOPONERROR}" != X && exit 1
  fi
else
  ERRS=`expr ${ERRS} + 1 `
  test X"${MTA_STOPONERROR}" != X && exit 1
fi

# ----------------
if test "${ERRS}" = "0"
then
  exit 0
else
  echo "${ERRS} error(s)"
  exit 1
fi
